package	jp.co.sds_corp.syslog.viewer.statistics; 

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.util.ResourceBundle;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import jp.co.sds_corp.syslog.SyslogEvent;
import jp.co.sds_corp.syslog.viewer.SyslogParam;
import jp.co.sds_corp.syslog.viewer.SyslogTable;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* syslogの統計情報を表示するダイアログです。
*/
public class StatisticsDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	SyslogParam		param;
	Vector<SyslogEvent>	vecLog;
	SyslogTable	table;
	ResourceBundle res;
	JTabbedPane	tp;
	GeneralPanel	general;
	GraphPanel		graph;
	JButton BTN_OK = new JButton( "Ok" );

	public StatisticsDialog( Dialog parent, SyslogParam param,
							Vector<SyslogEvent> vecLog, SyslogTable table )
	{
		super( parent );
		this.param = param;
		this.vecLog = vecLog;
		this.table = table;
		createControls();
	}

	public StatisticsDialog( Frame parent, SyslogParam param,
							Vector<SyslogEvent> vecLog, SyslogTable table )
	{
		super( parent );
		this.param = param;
		this.vecLog = vecLog;
		this.table = table;
		createControls();
	}

	public StatisticsDialog( SyslogParam param,
							Vector<SyslogEvent> vecLog, SyslogTable table )
	{
		super();
		this.param = param;
		this.vecLog = vecLog;
		this.table = table;
		createControls();
	}

	protected void createControls() {
		// setModal( true );
		res = ResourceBundle.getBundle( "resource.viewer" );
		String text;
		setResizable( false );
		text = res.getString( "statistics.title" );
		setTitle( text );
		setSize( 477, 421 );
		getContentPane().setLayout(
			new BoxLayout( getContentPane(), BoxLayout.Y_AXIS ) );
		setFont( param.getDefaultFont() );

		WindowUtility.setHideOnEscape( this );

		tp = new JTabbedPane();
		JPanel pnl;
		pnl = createGeneralPanel();
		text = res.getString( "statistics.tab1.text" );
		tp.addTab( text, pnl );

		pnl = createGraphPanel();
		text = res.getString( "statistics.tab2.text" );
		tp.addTab( text, pnl );

		getContentPane().add( tp );

		Box box1 = new Box( BoxLayout.X_AXIS );
		BTN_OK.setMnemonic( KeyEvent.VK_ESCAPE );
		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				onCancel();
			}
		});
		box1.add( BTN_OK );
		getContentPane().add( box1 );
	}

	protected JPanel createGeneralPanel() {
		general = new GeneralPanel( this, param, vecLog, table );
		return general;
	}

	protected JPanel createGraphPanel() {
		graph = new GraphPanel( this, param, vecLog, table );
		return graph;
	}

	public void onCancel() {
		setVisible( false );
	}

	public void setVisible( boolean var ) {
		update();
		super.setVisible( var );
	}

	public void update() {
		general.received();
		graph.received();
	}

}
